<script lang="ts">
  import { onMount } from "svelte";
  export let text: string;
  export let letterDelay: number = 10;
  let div: HTMLElement;

  onMount(() => {
    let observer = new IntersectionObserver(([entry]) => {
      if (entry.isIntersecting) {
        observer.disconnect();
        setTimeout(() => {
          for (let i = 0; i < text.length; i++) {
            if (text[i] == " ") {
              i++;
              setTimeout(() => {div.innerText += " " + text[i]}, i * letterDelay);
            } else
            {
              setTimeout(() => {div.innerText += text[i]}, i * letterDelay);
            }
          }
        }, 150);
      }
    });
    observer.observe(div);
  });
</script>

<div bind:this={div}></div>
